//
// Prototype definitions of functions called from this and other modules.
//
BOOL CALLBACK AdministerChannelsDlgProc(HWND, UINT, WPARAM, LPARAM);
VOID RegisterChannels(VOID);
VOID LoadChannels(VOID);;
VOID StartChannels(VOID);

// New in PocketPC version
BYTE AddChannelDialogBox(HINSTANCE , HWND , LPARAM );
BOOL CALLBACK AddChannelPropSheetProc(HWND, UINT, LPARAM);
BOOL CALLBACK AddChannelDlgProc1(HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK AddChannelDlgProc2(HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK AddChannelDlgProc3(HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK AddChannelDlgProc4(HWND, UINT, WPARAM, LPARAM );

int ModifyChannelDialogBox(HINSTANCE, HWND, LPARAM);
BOOL CALLBACK ModifyChannelPropSheetProc(HWND, UINT, LPARAM);
BOOL CALLBACK ModifyChannelDlgProc1(HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK ModifyChannelDlgProc2(HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK ModifyChannelDlgProc3(HWND, UINT, WPARAM, LPARAM );


//
// This structure is used to return information
// about the channel thread in response to a 
// TM_GET_CHANNEL_INFO message.
//
struct CHANNEL_INFO_EX {
	TCHAR ChannelName[10];	// The name of the channel.
	BYTE LogicalChNr;			// The logical channel nr. for the thread.
	TCHAR StationCode[5+1];	// Station code.
	TCHAR Component[4+1];		// Component.
	BOOL UseTrigging;			// TRUE if channel is checking for events.
	FLOAT ShortTermAverage;	// Trigger parameter;
	FLOAT LongTermAverage;	// Trigger parameter;
	BOOL ApplyFilter;			// TRUE if bandpass filtering is enabled.
	FLOAT FilterLow;			// Bandpass-filter parameter (Low cutoff freq.).
	FLOAT FilterHigh;			// Bandpass-filter parameter (High cutoff freq.).
	BOOL LogToDisk;		   // TRUE if channel logs data to disk.
	DWORD DevMngrThreadID;	// Thread-ID of channel's device-manager thread.
	TCHAR DeviceName[65];    // The name of the device this channel is bound to.
	BYTE DeviceChannel;		// The physical device channel used by this channel.
	PVOID DS;					// Pointer to channel's copy of DM's interf. structure.
};


//
// This structure is used to return information
// about the channel thread in response to a 
// TM_GET_CHANNEL_STATUS message.
//
struct CHANNEL_STATUS {
	BOOL Running;				// True if the channel is started.
	DWORD LastBlockUpdated; // The last updated block.
	DOUBLE LTA;					// Current LTA value;
	DOUBLE STA;					// Current STA value;
   LONG ChannelOffset;     // The currently calculated channel offset.
};


//
// This structure is used with the TM_GET_BLOCK_RANGE message.
//
struct BLOCK_RANGE {
   SYSTEMTIME StartTime;
   SYSTEMTIME EndTime;
   DWORD FirstBlock;
   DWORD LastBlock;
   DWORD NumBlocksInRange;
};


