#include "stdafx.h"
#include "Seislog.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>


//#include <windows.h>
//#include <stdio.h>
//#include <commctrl.h>
//#include "resource.h"
#include "Seislog.h"
#include "Process.h"
#include "DlgProcs.h"
#include "Monitor.h"
#include "WriteEvent.h"
#include "Library.h"

#define WINCE


//
// Theese are global variables used by functions in this file
//

extern DWORD ProcKeeperThreadID;
extern TCHAR EventFileDir[];
extern TCHAR SFileDir[];
extern TCHAR NetworkCode[];
extern TCHAR NetworkName[];
extern TCHAR ProgDir[];
extern TCHAR RngBufDir[];
extern TCHAR SerialPortGPS[];
extern BOOL AutoStart;
extern BOOL StartGPSThread;
extern BOOL AppendSeisanSubdirs;
extern DOUBLE MeanTimeBeforeGPRMC;

struct CHANDAT {
   BYTE ChannelNr;
   DWORD ThreadID;
   DWORD FirstBlock;
   DWORD LastBlock;
};

#ifdef WINCE
extern HINSTANCE hInst; // [PocketPC]
HWND hProgramSettingsDlg;
DWORD ThreadIDMonitor;     // ID for the currently active monitor thread
#endif

//
// Prototype declerations
//
DWORD WINAPI MonitorThrd(PVOID); 
DWORD WINAPI SpectraThrd(PVOID);


/*******************************************************************/
/*   Progress bar dialog box procedure.                            */
/*******************************************************************/

LRESULT CALLBACK ProgBarDlgProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
   HWND hWndDlgItem;
   PROGBARDLG_STARTUPINFO *SI;

   switch(message)  {
      case WM_INITDIALOG:
      SI=(PROGBARDLG_STARTUPINFO*)lParam;

      // Set the window text.
      SetWindowText(hwndDlg, SI->WindowText);
      
      // Set the static texts.
      SetDlgItemText(hwndDlg, IDC_STATIC1, SI->Static1);
      SetDlgItemText(hwndDlg, IDC_STATIC2, SI->Static2);
      SetDlgItemText(hwndDlg, IDC_STATIC3, SI->Static3);
      
      // Set the progressbar range.
      hWndDlgItem=GetDlgItem(hwndDlg, IDC_PROGRESS1);
      SendMessage(hWndDlgItem, PBM_SETRANGE, 0, MAKELPARAM(0, SI->ProgBarMaxRange)); 
      SendMessage(hWndDlgItem, PBM_SETSTEP, (WPARAM) SI->ProgBarStepIncr, 0); 
      return TRUE;

      case WM_STEPPROGRESSBAR:
      // Increase the progressbar position.  
      hWndDlgItem=GetDlgItem(hwndDlg, IDC_PROGRESS1);
      SendMessage(hWndDlgItem, PBM_STEPIT, 0, 0); 
      break;

      case WM_PROGRESSBARWND_SETTEXTS:
      // Set the static texts.   
      SI=(PROGBARDLG_STARTUPINFO*)lParam;
      SetDlgItemText(hwndDlg, IDC_STATIC1, SI->Static1);
      SetDlgItemText(hwndDlg, IDC_STATIC2, SI->Static2);
      SetDlgItemText(hwndDlg, IDC_STATIC3, SI->Static3);
      break;


      case WM_PROGRESSBAR_RECONFIG:
      // Reset progressbar and set new range/step incr. values.
      SI=(PROGBARDLG_STARTUPINFO*)lParam;
      hWndDlgItem=GetDlgItem(hwndDlg, IDC_PROGRESS1);
      SendMessage(hWndDlgItem, PBM_SETPOS, 0, 0); 
      SendMessage(hWndDlgItem, PBM_SETRANGE, 0, MAKELPARAM(0, SI->ProgBarMaxRange)); 
      SendMessage(hWndDlgItem, PBM_SETSTEP, (WPARAM) SI->ProgBarStepIncr, 0); 
      break;

   }

   return FALSE;
}


/*******************************************************************/
/*   Dialog box procedure for the 'Monitor channels' dialog.       */
/*******************************************************************/
#ifdef WINCE

LRESULT CALLBACK MonitorChannelsDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

   SHINITDLGINFO shidi;
   HWND hWndDlgItem;
   BYTE Index; 
   TCHAR MessageText[100], ProcName[65], ChannelName[10];
   DWORD dwIndex, ThreadID; 
   STARTINFO_MONITOR SIMON;
   extern CHANNEL_INFO Channels[MAX_NUM_OF_CHANNELS];
   extern BYTE NumRegisteredChannels;  
   bool bSpectraWnd;
   int nStrLen;
   LPTSTR lpString;
   char chr[21];
   int i;

	   
   switch(message)  {

      case WM_INITDIALOG:

	  // Create a Done button and size it. New in PocketPC version.
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);
	  
	  // Check if monitor or spectra dialog chosen
	  nStrLen = GetDlgItemText(hWndDlg, IDC_PROP, lpString,20);
	  i=GetLastError();
	  bSpectraWnd = false;
	  
	  //nStrLen = GetWindowText(hWndDlg, lpString, 20);
	  for (i=0;i<nStrLen;i++)  {
		  chr[i] = *lpString;
		  lpString++;
	  }
	  chr[nStrLen]=0;
	  bSpectraWnd = false;   
	  if (strcmp(chr,"Settings...") == 0) {bSpectraWnd = true;}
	  // Disable the "Properties..." button
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
	  EnableWindow(hWndDlgItem, FALSE); 

      // Initialize the 'Channels' combo box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
      for (Index=0;Index<NumRegisteredChannels;Index++) {
         wcscpy(ProcName, Channels[Index].ChannelName);
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)ProcName);
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)Index);
         //if (Index==0) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }


	  // Initialise the Thread ID to 0,
	  // indicating that there is initially no active thread
	  ThreadIDMonitor = 0;
	  ThreadID        = 0;


      // Bring window to front.
      BringWindowToTop(hWndDlg);
      return TRUE; 

      case WM_COMMAND:
      switch(LOWORD(wParam)) {

		case IDC_CHANNEL:

		switch (HIWORD(wParam)) { 
            case CBN_SELCHANGE:

		 // Disable the "channels" combo box
		 hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
		 EnableWindow(hWndDlgItem, FALSE); 

	     // Disable the "Properties..." button
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
	     EnableWindow(hWndDlgItem, FALSE); 

         // Disable the "OK" button
		 SHDoneButton(hWndDlg, SHDB_HIDE);

		 
         // Get selection from combo box. (Get the channel name).
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
         dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
         SendMessage(hWndDlgItem, CB_GETLBTEXT, (WPARAM)dwIndex, (LPARAM)(LPCTSTR)ChannelName);


         // Check that the channel is running.
         wcscpy(ProcName, ChannelName);
         ThreadID=GetProcessThreadIDByName(ProcName);
         
		 if (ThreadID) { // If channel is running
			 
			 // Stop the monitored thread, if there is one.
		   if (ThreadIDMonitor)
		   {
		       // Send stop signal to the thread.
			   PostThreadMessage(ThreadIDMonitor, TM_EXIT, 0, 0); 

			   // Wait for the thread to exit.
			   while (PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(200);

			}
            // Start monitor thread.

		    SIMON.hParent = hWndDlg;
            SIMON.LogicalChannelNr=(BYTE)dwIndex+1;
            SIMON.ChThreadID=ThreadID;
			CreateThread(NULL, 0, MonitorThrd, (PVOID)&SIMON, 0, &ThreadIDMonitor);
            while (!PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(50);

			// Give the thread some extra time to open the window
			Sleep(1000);

         } else {
            // The channel is not running.
            wcscpy(MessageText, TEXT("Channel is not running.\nCan not monitor this channel."));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONHAND);
         }

		 // Enable the "OK" button
         SHDoneButton(hWndDlg, SHDB_SHOW);

		 // Enable the "Properties..." button
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
		 EnableWindow(hWndDlgItem, TRUE); 

		 // Enable Combobox
    	 hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
		 EnableWindow(hWndDlgItem, TRUE); 
		 break;
		}
		break;

		case IDC_PROP:
		   PostThreadMessage(ThreadIDMonitor, TM_MONITOR_PROPERTIES, 0, 0);
	       break;
	
        case IDOK:  // Changed in PocketPC version. ID is IDC_BUTTON2 in Win9X version.
   

		 // Stop the monitored thread
   
		   if (ThreadIDMonitor)
		   {
		       // Send stop signal to the thread.
			   PostThreadMessage(ThreadIDMonitor, TM_EXIT, 0, 0); 

			   // Wait for the thread to exit.
			   while (PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(200);
			}


         // Close the dialog box
         EndDialog(hWndDlg , 0);
         break;

      }
      return FALSE;
   }
   return FALSE;
}

#endif

/*******************************************************************/
/*   Dialog box procedure for the 'Program settings' dialog.       */
/*******************************************************************/
LRESULT CALLBACK ProgramSettingsDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
   TCHAR Message[100];
   SHINITDLGINFO shidi;


   switch(message)  {
      case WM_INITDIALOG:


	  // Create a Done button and size it (PocketPC specific).  
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);

      // Initialize the 'Program base directory' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir);

      // Initialize the 'Ringbuffer directory' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir);

      // Initialize the 'S-file directory' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir);

      // Initialize the 'Automatically append ...' check box.
      CheckDlgButton(hWndDlg, IDC_CHECK1, BST_UNCHECKED); 
      if (AppendSeisanSubdirs) CheckDlgButton(hWndDlg, IDC_CHECK1, BST_CHECKED); 

      // Initialize the 'Event file directory' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir);

      // Initialize the 'Short network name' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode);

      // Initialize the 'Long network name' edit box.
      SetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName);

      // Initialize the autostart check box.
      CheckDlgButton(hWndDlg, IDC_CHECK2, BST_UNCHECKED); 
      if (AutoStart) CheckDlgButton(hWndDlg, IDC_CHECK2, BST_CHECKED); 


	  SetForegroundWindow(hWndDlg); // [PocketPC] Neccesary to display dialog properly 

      return TRUE; 


      case WM_COMMAND:
      switch(LOWORD(wParam)) {
         case IDOK:
         //
         // This is the 'Done' button.
         //
         //
         // Read the 'Program base directory' edit box.
         GetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir, MAX_PATH+1);
         StrRmvTrailingSpaces(ProgDir); // Remove all spaces in front of the string.
			// Try to create this directory if it does not already exist.
			if (!ExistDirectory(ProgDir)) CreateMultiLevelDir(ProgDir);
         // Check that directory was sucessfully created.
         if (!ExistDirectory(ProgDir)) {
            wcscpy(Message, TEXT("Unable to create directory.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
            SendDlgItemMessage(hWndDlg, IDC_EDIT1, EM_SETSEL, 0, -1);
            return FALSE;
         }

         //
         // Read the 'Ringbuffer directory' edit box.
         GetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir, MAX_PATH+1);
         StrRmvTrailingSpaces(RngBufDir);
			// Try to create this directory if it does not already exist.
			if (!ExistDirectory(RngBufDir)) CreateMultiLevelDir(RngBufDir);
         // Check that directory was sucessfully created.
         if (!ExistDirectory(RngBufDir)) {
            wcscpy(Message, TEXT("Unable to create directory.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT2));
            SendDlgItemMessage(hWndDlg, IDC_EDIT2, EM_SETSEL, 0, -1);
            return FALSE;
         }

         //
         // Read the 'S-file directory' edit box.
         GetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir, MAX_PATH+1);
         StrRmvTrailingSpaces(SFileDir);
			// Try to create this directory if it does not already exist.
			if (!ExistDirectory(SFileDir)) CreateMultiLevelDir(SFileDir);
         // Check that directory was sucessfully created.
         if (!ExistDirectory(SFileDir)) {
            wcscpy(Message, TEXT("Unable to create directory.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT3));
            SendDlgItemMessage(hWndDlg, IDC_EDIT3, EM_SETSEL, 0, -1);
            return FALSE;
         }

         //
         // Read the 'Automatically append ...' check box.
         AppendSeisanSubdirs=(IsDlgButtonChecked(hWndDlg, IDC_CHECK1)==BST_CHECKED);

         //
         // Read the 'Event file directory' edit box.
         GetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir, MAX_PATH+1);
         StrRmvTrailingSpaces(EventFileDir);
			// Try to create this directory if it does not already exist.
			if (!ExistDirectory(EventFileDir)) CreateMultiLevelDir(EventFileDir);
         // Check that directory was sucessfully created.
         if (!ExistDirectory(EventFileDir)) {
            wcscpy(Message, TEXT("Unable to create directory.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT4));
            SendDlgItemMessage(hWndDlg, IDC_EDIT4, EM_SETSEL, 0, -1);
            return FALSE;
         }
            
         //
         // Read the short network name.
         GetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode, 6);
         StrRmvSpaces(NetworkCode);
         if (wcslen(NetworkCode)<3) {
            // The short network name must be min 3, max 5, characters long.
            wcscpy(Message, TEXT("The short network name must be at least 3 characters long.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT5));
            SendDlgItemMessage(hWndDlg, IDC_EDIT5, EM_SETSEL, 0, -1);
            return FALSE;
         }

         //
         // Read the long network name.
         GetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName, 30);
         StrRmvTrailingSpaces(NetworkName);
         if (!wcslen(NetworkName)) {
            // A long network name must be entered.
            wcscpy(Message, TEXT("The long network name is missing.\n"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT6));
            return FALSE;
         }
        
         //
         // Read the 'Autostart' check box.
         AutoStart=(IsDlgButtonChecked(hWndDlg, IDC_CHECK2)==BST_CHECKED);

         //
         // Close the dialog box
         EndDialog(hWndDlg , 1);
         break;


		 case IDCANCEL:
         //
         // This is the 'Cancel' button.
         //
         //
         // Close the dialog box
         EndDialog(hWndDlg , 0);
		 break;

      }
      return FALSE;
   }
   return FALSE;
}





/*******************************************************************/
/*   Dialog box procedure for the 'About Seislog' dialog.          */
/*******************************************************************/

LRESULT CALLBACK AboutDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#ifdef WINCE
	SHINITDLGINFO shidi; // New in PocketPC version
#endif
	extern TCHAR ProgVer[];

	switch (message)
	{
		case WM_INITDIALOG:
#ifdef WINCE
			// Create a Done button and size it. New in PocketPC version.
			shidi.dwMask = SHIDIM_FLAGS;
			 shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
#endif
			// Initialize the static text giving the program version.
			SetDlgItemText(hDlg, IDC_STATIC2, ProgVer); 

			// Bring window to front.
			BringWindowToTop(hDlg);

			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				// Close the dialog box
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

#ifdef WINCE

/*******************************************************************/
/*  Dialog box procedure for the 'Directories' property sheet page */
/*  in the 'Program settings' dialog.                              */
/*******************************************************************/

BOOL CALLBACK ProgramSettingsDlgProc1(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR Message[100];

	switch(message)  {

	case WM_INITDIALOG:

		// Initialize the 'Program base directory' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir);

		// Initialize the 'Ringbuffer directory' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir);

		// Initialize the 'S-file directory' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir);

		// Initialize the 'Automatically append ...' check box.
		CheckDlgButton(hWndDlg, IDC_CHECK1, BST_UNCHECKED); 
		if (AppendSeisanSubdirs) CheckDlgButton(hWndDlg, IDC_CHECK1, BST_CHECKED); 

		// Initialize the 'Event file directory' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir);


		return TRUE; 
	
	case WM_NOTIFY:

		if (((NMHDR *)lParam)->code == PSN_APPLY)
		{
			 // Read the 'Program base directory' edit box.
			 GetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir, MAX_PATH+1);
			 StrRmvTrailingSpaces(ProgDir); // Remove all spaces in front of the string.
			 // Try to create this directory if it does not already exist.
			 if (!ExistDirectory(ProgDir)) CreateMultiLevelDir(ProgDir);
			 // Check that directory was sucessfully created.
			 if (!ExistDirectory(ProgDir)) {
				wcscpy(Message, TEXT("Unable to create directory.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT1, ProgDir);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
				SendDlgItemMessage(hWndDlg, IDC_EDIT1, EM_SETSEL, 0, -1);
            
				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 0);
				
				// Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
			 }

			 //
			 // Read the 'Ringbuffer directory' edit box.
			 GetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir, MAX_PATH+1);
			 StrRmvTrailingSpaces(RngBufDir);
			 // Try to create this directory if it does not already exist.
			 if (!ExistDirectory(RngBufDir)) CreateMultiLevelDir(RngBufDir);
			 // Check that directory was sucessfully created.
			 if (!ExistDirectory(RngBufDir)) {
				wcscpy(Message, TEXT("Unable to create directory.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT2, RngBufDir);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT2));
				SendDlgItemMessage(hWndDlg, IDC_EDIT2, EM_SETSEL, 0, -1);
				
				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 0);
				
				// Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
			 }

			 //
			 // Read the 'S-file directory' edit box.
			 GetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir, MAX_PATH+1);
			 StrRmvTrailingSpaces(SFileDir);
			 // Try to create this directory if it does not already exist.
			 if (!ExistDirectory(SFileDir)) CreateMultiLevelDir(SFileDir);
			 // Check that directory was sucessfully created.
			 if (!ExistDirectory(SFileDir)) {
				wcscpy(Message, TEXT("Unable to create directory.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT3, SFileDir);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT3));
				SendDlgItemMessage(hWndDlg, IDC_EDIT3, EM_SETSEL, 0, -1);
            
				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 0);
				
				// Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
			 }

			 //
			 // Read the 'Automatically append ...' check box.
			 AppendSeisanSubdirs=(IsDlgButtonChecked(hWndDlg, IDC_CHECK1)==BST_CHECKED);

			 //
			 // Read the 'Event file directory' edit box.
			 GetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir, MAX_PATH+1);
			 StrRmvTrailingSpaces(EventFileDir);
			 // Try to create this directory if it does not already exist.
			 if (!ExistDirectory(EventFileDir)) CreateMultiLevelDir(EventFileDir);
			 // Check that directory was sucessfully created.
			 if (!ExistDirectory(EventFileDir)) {
				wcscpy(Message, TEXT("Unable to create directory.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT4, EventFileDir);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT4));
				SendDlgItemMessage(hWndDlg, IDC_EDIT4, EM_SETSEL, 0, -1);
            
				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 0);

				// Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
			 }
            

			 //Close the dialog box
			 SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
			 return TRUE;
		 
		}
		return FALSE;
	}
	return FALSE;
}


/**********************************************************************/
/*  Dialog box procedure for the 'Network names' property sheet page  */
/*  in the 'Program settings' dialog.                                 */
/**********************************************************************/

BOOL CALLBACK ProgramSettingsDlgProc2(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR Message[100];

	switch(message)  {

	case WM_INITDIALOG:

		// Initialize the 'Short network name' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode);

		// Initialize the 'Long network name' edit box.
		SetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName);

		return TRUE; 
	
	case WM_NOTIFY:

		if (((NMHDR *)lParam)->code == PSN_APPLY)
		{
			//
			 // Read the short network name.
			 GetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode, 6);
			 StrRmvSpaces(NetworkCode);
			 if (wcslen(NetworkCode)<3) {
				// The short network name must be min 3, max 5, characters long.
				wcscpy(Message, TEXT("The short network name must be at least 3 characters long.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT5, NetworkCode);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT5));
				SendDlgItemMessage(hWndDlg, IDC_EDIT5, EM_SETSEL, 0, -1);

				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 1);

				// Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
			 }

			 //
			 // Read the long network name.
			 GetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName, 30);
			 StrRmvTrailingSpaces(NetworkName);
			 if (!wcslen(NetworkName)) {
				// A long network name must be entered.
				wcscpy(Message, TEXT("The long network name is missing.\n"));
				MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
				SetDlgItemText(hWndDlg, IDC_EDIT6, NetworkName);
				SetFocus(GetDlgItem(hWndDlg, IDC_EDIT6));

				// Change to this propery sheet page
				PropSheet_SetCurSel(hProgramSettingsDlg, hWndDlg, 1);

				// [PocketPC] Prevent closing 
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;

			 }

			 //Close the dialog box
			 SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
			 return TRUE;
		 
		}
		return FALSE;
	}
	return FALSE;
}


/*******************************************************************/
/*  Dialog box procedure for the 'Startup' property sheet page         */
/*  in the 'Program settings' dialog.                              */
/*******************************************************************/

BOOL CALLBACK ProgramSettingsDlgProc3(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)  {

	case WM_INITDIALOG:

		// Initialize the autostart check box.
		CheckDlgButton(hWndDlg, IDC_CHECK2, BST_UNCHECKED); 
		if (AutoStart) CheckDlgButton(hWndDlg, IDC_CHECK2, BST_CHECKED); 

		return TRUE; 
	
	case WM_NOTIFY:

		if (((NMHDR *)lParam)->code == PSN_APPLY)
		{
       
			 //
			 // Read the 'Autostart' check box.
			 AutoStart=(IsDlgButtonChecked(hWndDlg, IDC_CHECK2)==BST_CHECKED);

			 //Close the dialog box
			 SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
			 return TRUE;
		 
		}
		return FALSE;
	}
	return FALSE;
}


/*******************************************************************/
/*  Callback for the 'Program settings' property sheet.            */
/*  This procedure is called when the property sheet               */
/*  is being created and initialized.                              */
/*******************************************************************/

BOOL CALLBACK ProgramSettingsPropSheetProc(HWND hwndDlg, UINT uMsg, LPARAM lParam )
{
	
	SHINITDLGINFO shidi;

	switch (uMsg)
	{
		
	case PSCB_INITIALIZED: // Note: This may be the wrong message to do this!
		 
		// Initialize handle to the Property Sheet
		hProgramSettingsDlg = hwndDlg;
	
		// Create a Done button and size it.  
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hwndDlg;
		SHInitDialog(&shidi);
		
		return TRUE;
	}
	return TRUE;
}

/*******************************************************************/
/* Opens the Program Settings property sheet                       */
/*******************************************************************/
BOOL ProgramSettingsDialogBox(HWND hWnd)
{
	  //[PocketPC]
	PROPSHEETHEADER psh;    // The entire Property Sheet
	PROPSHEETPAGE   psp[3]; // The property pages
	INT i;

	  		// Init page structures with generic information.
		memset (&psp, 0, sizeof (psp));      // Zero out all unused values.
		for (i = 0; i < 3; i++) {
			psp[i].dwSize = sizeof (PROPSHEETPAGE);
			psp[i].dwFlags = PSP_DEFAULT | PSP_PREMATURE;
			psp[i].hInstance = hInst;         // Instance handle where the
		}                                     // dialog templates are located
		// Now do the page specific stuff.
		psp[0].pszTemplate = MAKEINTRESOURCE(IDD_PROGRAM_SETTINGS_1); // Name of dialog resource for page 1
		psp[0].pfnDlgProc = ProgramSettingsDlgProc1;    // Pointer to dialog proc for page 1

		psp[1].pszTemplate = MAKEINTRESOURCE(IDD_PROGRAM_SETTINGS_2); // Name of dialog resource for page 2
		psp[1].pfnDlgProc = ProgramSettingsDlgProc2;    // Pointer to dialog proc for page 2

		psp[2].pszTemplate = MAKEINTRESOURCE(IDD_PROGRAM_SETTINGS_3); // Name of dialog resource for page 2
		psp[2].pfnDlgProc = ProgramSettingsDlgProc3;    // Pointer to dialog proc for page 2


		// Init property sheet header structure.
		psh.dwSize = sizeof (PROPSHEETHEADER);
		psh.dwFlags = PSH_PROPSHEETPAGE | PSH_USECALLBACK;    // We are using templates not handles.
		psh.hwndParent = hWnd;              // Handle of the owner window
		psh.hInstance = hInst;              // Instance handle of the application
		psh.pszCaption = TEXT ("Program Settings");
		psh.nPages = 3;                    // Number of pages
		psh.nStartPage = 0;                  // Index of page to be shown first
		psh.ppsp = psp;                     // Pointer to page structures
		psh.pfnCallback = ProgramSettingsPropSheetProc;   

		// Create property sheet.  This returns when the user dismisses the sheet
		// by tapping OK or the Close button.

		PropertySheet (&psh);

		return 0;
}

#endif


/*********************************************************************/
/*   Dialog box procedure for the 'Configure external GPS' dialog.   */
/*********************************************************************/
BOOL CALLBACK ConfigureExternalGPSDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

#ifdef WINCE
	// Used to create full screen dialogs
	// with OK buttons on navigation bar.
	SHINITDLGINFO shidi; 
#endif

   HWND hWndDlgItem;
   TCHAR str10[11], Message[100];
   DWORD dwIndex;
   CHAR PortNr;
   TCHAR Ports[16][6]={TEXT("COM1"),TEXT("COM2"), TEXT("COM3"), TEXT("COM4"), TEXT("COM5"), TEXT("COM6"), TEXT("COM7"), TEXT("COM8")
                    , TEXT("COM9"),TEXT("COM10"),TEXT("COM11"),TEXT("COM12"),TEXT("COM13"),TEXT("COM14"),TEXT("COM15"),TEXT("COM16")};


   switch(message)  {
      case WM_INITDIALOG:

#ifdef WINCE	  
	  // Create full screen dialog with OK button on navigation bar
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);		  
#endif		  
		  
	  // Initialize the 'Enable GPS syncronization of ...' check box.
      CheckDlgButton(hWndDlg, IDC_CHECK1, BST_UNCHECKED); 
      if (StartGPSThread) {
         CheckDlgButton(hWndDlg, IDC_CHECK1, BST_CHECKED);

         // Enable the boxes below.
         EnableWindow(GetDlgItem(hWndDlg, IDC_COMBO1), TRUE);
         EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), TRUE);
      }

      // Initialize the serial port combo box.
      if (!wcslen(SerialPortGPS)) wcscpy(SerialPortGPS, TEXT("COM1"));
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
      for (PortNr=0;PortNr<16;PortNr++) {
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)Ports[PortNr]);
         SendMessage(hWndDlgItem, CB_SETITEMDATA, dwIndex, PortNr);
         if (!wcscmp(SerialPortGPS, Ports[PortNr])) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }

      // Initialize the edit box.
      swprintf(str10, TEXT("%.3f"), MeanTimeBeforeGPRMC);
      SetDlgItemText(hWndDlg, IDC_EDIT1, str10);
      
      return TRUE; 


      case WM_COMMAND:
      switch(LOWORD(wParam)) {
         case IDC_CHECK1:
         //
         // This is the 'Enable GPS syncronization ...' checkbox.
         switch (HIWORD(wParam)) { 
            case BN_CLICKED:
            if (IsDlgButtonChecked(hWndDlg, IDC_CHECK1)==BST_CHECKED) {
               // Enable the combo/edit boxes.
               EnableWindow(GetDlgItem(hWndDlg, IDC_COMBO1), TRUE);
               EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), TRUE);
            } else {
               // Disable the the combo/edit boxes.
               EnableWindow(GetDlgItem(hWndDlg, IDC_COMBO1), FALSE);
               EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), FALSE);
            }
         }
         break;
         case IDOK:
         //
         // This is the 'Done' button.
         //
         // Read the 'Enable GPS syncronization of ...' check box.
         StartGPSThread=(IsDlgButtonChecked(hWndDlg, IDC_CHECK1)==BST_CHECKED);
         //
         // Read the serial port combo box.
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
         dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
         SendMessage(hWndDlgItem, CB_GETLBTEXT, dwIndex, (LPARAM)SerialPortGPS);
         //
         // Read the 'mean time' edit box.
         GetDlgItemText(hWndDlg, IDC_EDIT1, str10, 10);

		 // Convert Unicode string to ANSI string
		 char strTemp10[11];
		 wcstombs(strTemp10, str10, 11);
		 MeanTimeBeforeGPRMC=atof(strTemp10);
		 
		 

         if (MeanTimeBeforeGPRMC<-1.0 || MeanTimeBeforeGPRMC>1.0) {
            wcscpy(Message, TEXT("Invalid value entered.\n"));
            wcscat(Message, TEXT("Please enter a value between -1.0 and 1.0"));
            MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
            SendDlgItemMessage(hWndDlg, IDC_EDIT1, EM_SETSEL, 0, -1); 
            break;
         }
         //
         // Close the dialog box
         EndDialog(hWndDlg , 0);
         break;
      }
      return FALSE;
   }
   return FALSE;
}


/*******************************************************************/
/*   Dialog box procedure for the 'Spectra' dialog.       */
/*******************************************************************/
#ifdef WINCE

LRESULT CALLBACK SpectraChannelsDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

   SHINITDLGINFO shidi;
   HWND hWndDlgItem;
   BYTE Index; 
   TCHAR MessageText[100], ProcName[65], ChannelName[10];
   DWORD dwIndex, ThreadID; 
   STARTINFO_MONITOR SIMON;
   extern CHANNEL_INFO Channels[MAX_NUM_OF_CHANNELS];
   extern BYTE NumRegisteredChannels;  

	   
   switch(message)  {

      case WM_INITDIALOG:

	  // Create a Done button and size it. New in PocketPC version.
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);
	  
	  // Disable the "Properties..." button
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
	  EnableWindow(hWndDlgItem, FALSE); 

      // Initialize the 'Channels' combo box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
      for (Index=0;Index<NumRegisteredChannels;Index++) {
         wcscpy(ProcName, Channels[Index].ChannelName);
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)ProcName);
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)Index);
         //if (Index==0) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }


	  // Initialise the Thread ID to 0,
	  // indicating that there is initially no active thread
	  ThreadIDMonitor = 0;
	  ThreadID        = 0;


      // Bring window to front.
      BringWindowToTop(hWndDlg);
      return TRUE; 

      case WM_COMMAND:
      switch(LOWORD(wParam)) {

		case IDC_CHANNEL:

		switch (HIWORD(wParam)) { 
            case CBN_SELCHANGE:

		 // Disable the "channels" combo box
		 hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
		 EnableWindow(hWndDlgItem, FALSE); 

	     // Disable the "Properties..." button
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
	     EnableWindow(hWndDlgItem, FALSE); 

         // Disable the "OK" button
		 SHDoneButton(hWndDlg, SHDB_HIDE);

		 
         // Get selection from combo box. (Get the channel name).
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
         dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
         SendMessage(hWndDlgItem, CB_GETLBTEXT, (WPARAM)dwIndex, (LPARAM)(LPCTSTR)ChannelName);


         // Check that the channel is running.
         wcscpy(ProcName, ChannelName);
         ThreadID=GetProcessThreadIDByName(ProcName);
         
		 if (ThreadID) { // If channel is running
			 
			 // Stop the monitored thread, if there is one.
		   if (ThreadIDMonitor)
		   {
		       // Send stop signal to the thread.
			   PostThreadMessage(ThreadIDMonitor, TM_EXIT, 0, 0); 

			   // Wait for the thread to exit.
			   while (PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(200);

			}
            // Start monitor thread.

		    SIMON.hParent = hWndDlg;
            SIMON.LogicalChannelNr=(BYTE)dwIndex+1;
            SIMON.ChThreadID=ThreadID;
            CreateThread(NULL, 0, SpectraThrd, (PVOID)&SIMON, 0, &ThreadIDMonitor);
            while (!PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(50);

			// Give the thread some extra time to open the window
			Sleep(1000);

         } else {
            // The channel is not running.
            wcscpy(MessageText, TEXT("Channel is not running.\nCan not monitor this channel."));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONHAND);
         }

		 // Enable the "OK" button
         SHDoneButton(hWndDlg, SHDB_SHOW);

		 // Enable the "Properties..." button
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_PROP);
		 EnableWindow(hWndDlgItem, TRUE); 

		 // Enable Combobox
    	 hWndDlgItem=GetDlgItem(hWndDlg, IDC_CHANNEL);
		 EnableWindow(hWndDlgItem, TRUE); 
		 break;
		}
		break;

		case IDC_PROP:
           PostThreadMessage(ThreadIDMonitor, TM_SPECTRA_PROPERTIES, 0, 0);
		   break;
	
        case IDOK:  // Changed in PocketPC version. ID is IDC_BUTTON2 in Win9X version.
   

		 // Stop the monitored thread
   
		   if (ThreadIDMonitor)
		   {
		       // Send stop signal to the thread.
			   PostThreadMessage(ThreadIDMonitor, TM_EXIT, 0, 0); 

			   // Wait for the thread to exit.
			   while (PostThreadMessage(ThreadIDMonitor, TM_DUMMY, 0, 0)) Sleep(200);
			}


         // Close the dialog box
         EndDialog(hWndDlg , 0);
         break;

      }
      return FALSE;
   }
   return FALSE;
}

#endif