
//#define STRICT

#include "stdafx.h"

#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
//#include "resource.h"
#include "seislog.h"
#include "library.h"

extern DWORD ProcKeeperThreadID;
extern HWND hWndStatus;
extern TCHAR StatusBarText[];

#define WINCE


#ifdef WINCE
/*********************************************************************/
/* [PocketPC Specific]                                               */
/* Change the check state of a button control                        */
/*                                                                   */
/* This function is new in PocketPC version, and implements the      */
/* SDK function with the same name.                                  */
/*                                                                   */
/* uCheck specifies the check state of the button.                   */
/* This parameter can be one of the following values:                */
/*   BST_CHECKED        Sets the button state to checked.            */
/*   BST_INDETERMINATE  Sets the button state to grayed, indicating  */
/*                      an  indeterminate state. Use this value only */
/*                      if the button has the BS_3STATE or           */
/*                      BS_AUTO3STATE style.                         */ 
/*   BST_UNCHECKED      Sets the button state to cleared             */
/*********************************************************************/


BOOL CheckDlgButton(HWND hDlg, int nIDButton, UINT uCheck)
{
    HWND hWnd = (HWND) GetDlgItem(hDlg, nIDButton);
    return SendMessage(hWnd, BM_SETCHECK, (WPARAM) uCheck, (LPARAM) 0);
}


/*********************************************************************/
/* [PocketPC Specific]                                               */
/* Determines whether a button control has a check mark next to it   */
/*                                                                   */
/* This function is new in PocketPC version, and implements the      */
/* SDK function with the same name.                                  */
/*********************************************************************/


UINT IsDlgButtonChecked(HWND hDlg, int nIDButton)
{
  HWND hWnd = (HWND) GetDlgItem(hDlg, nIDButton);

  LRESULT state = SendMessage((HWND) hWnd, BM_GETCHECK, (WPARAM) 0,  (LPARAM) 0);

  return (BST_CHECKED == state);

}

/*********************************************************************/
/* Checks if a file exists.                                          */
/* The path and the filename must be given separatly.                */
/*                                                                   */
/* [PocketPC Specific] This function is completly rewritten because  */
/* of unsupported API call. Slashes ("//") are appended between path */
/* and filename                      .                               */
/*********************************************************************/

BOOL ExistFile(LPCTSTR Path, LPCTSTR FileName)
{
	WIN32_FIND_DATA  wfd;
	HANDLE           hFoundFile;

	// Create filename width full path

	TCHAR *strFullName = new TCHAR[wcslen(Path)+wcslen(FileName)+3];

	// Copy path and append slashes and filname

	wcscpy(strFullName, Path);
	
	wcscat(strFullName, TEXT("//"));
	
	wcscat(strFullName, FileName); 

	// Check if file exist

	hFoundFile = (HANDLE) ::FindFirstFile(strFullName, &wfd);
	
	if (INVALID_HANDLE_VALUE == hFoundFile)
	{
		::FindClose(hFoundFile);
		return FALSE;
	}
	else
	{
		::FindClose(hFoundFile);
		return TRUE;
	}
}
#endif

/*********************************************************************/
/* Checks if a directory exists.                                     */
/*                                                                   */
/* This function is completly rewritten because                      */
/* of unsupported API call                      .                    */
/*********************************************************************/
BOOL ExistDirectory(LPCTSTR Path) 
{
	WIN32_FIND_DATA  wfd;
	HANDLE           hFoundFile;


	hFoundFile = (HANDLE) ::FindFirstFile(Path, &wfd);
	
	if (INVALID_HANDLE_VALUE == hFoundFile)
	{
		::FindClose(hFoundFile);
		return FALSE;
	}
	else
	{
		::FindClose(hFoundFile);
		return TRUE;
	}
}




/*********************************************************************/
/* Creates a mulitilevel directory.                                  */
/*                                                                   */
/* [PocketPC Specific] CreateDirectory on PocketPC does not accept   */
/* directories ending with '\\', so this character is not copied     */
/* into the the Path2 variable in this version.                      */
/*********************************************************************/
BOOL CreateMultiLevelDir(LPCTSTR Path)
{
   TCHAR Path1[MAX_PATH], Path2[MAX_PATH];
	int StrSize, Index;

	// Get the string lengt of the path.
	StrSize=wcslen(Path);

	// If path is empty then exit.
	if (!StrSize) return FALSE;

	// If path already exist then exit.
	if (ExistDirectory(Path)) return TRUE;

	// Copy path to local variable.
   wcscpy(Path1, Path);

	// Make sure path ends with a backslash.
   if (Path1[StrSize-1]!='\\') {
		wcscat(Path1, TEXT("\\\0")); StrSize++;
	}

	// Create directories.
	for (Index=0;Index<StrSize;Index++) {
		if (Path1[Index]=='\\') {
			wcsncpy(Path2, Path1, Index); Path2[Index]=0;
			if (!ExistDirectory(Path2)) CreateDirectory(Path2, NULL);
		}
	}

	return ExistDirectory(Path);
}



/*********************************************************************/
/* Swap WORD bytes.                                                  */ 
/*********************************************************************/
WORD SwapWordBytes(WORD Value) 
{
   BYTE ByteL, ByteH;

   ByteL=LOBYTE(Value);
   ByteH=HIBYTE(Value);

   return ByteL*256 + ByteH;  
}




/*********************************************************************/
/* Swap DWORD bytes.                                                  */ 
/*********************************************************************/
DWORD SwapDWordBytes(DWORD Value) 
{
   BYTE ByteL, ByteML;
   BYTE ByteMH, ByteH;
   DWORD RetValue;

   ByteL =HIBYTE(HIWORD(Value));
   ByteML=LOBYTE(HIWORD(Value));
   ByteMH=HIBYTE(LOWORD(Value));
   ByteH =LOBYTE(LOWORD(Value));

   RetValue=ByteH*256*256*256;
   RetValue=RetValue + ByteMH*256*256;
   RetValue=RetValue + ByteML*256;
   RetValue=RetValue + ByteL;

   return RetValue;  
}





/*********************************************************************/
/* Creates and returns a Long Int from 4 bytes.                      */ 
/*********************************************************************/
LONG CreateLongIntFrom4Bytes(BYTE HighByte, BYTE MedHByte, 
                             BYTE MedLByte, BYTE LowByte) {
   long int value;

   value=(long)HighByte;
   value=value << 8;
   value=value+(long)MedHByte;
   value=value << 8;
   value=value+(long)MedLByte;
   value=value << 8;
   value=value+(long)LowByte;
   return value;  
}



/*********************************************************************/
/* Creates and returns a Long Int from 3 bytes.                      */ 
/*********************************************************************/
LONG CreateLongIntFrom3Bytes(BYTE HighByte, BYTE MedByte, BYTE LowByte) {
   long int value;

   value=(long)HighByte;
   value=value << 8;
   value=value+(long)MedByte;
   value=value << 8;
   value=value+(long)LowByte;
   value=value << 8;
   return (value >> 8); 
}


/*********************************************************************/
/* Creates and returns a Long Int from 2 bytes.                      */ 
/*********************************************************************/
LONG CreateLongIntFrom2Bytes(BYTE HighByte, BYTE LowByte) {
   long int value;

   value=(long)HighByte;
   value=value << 8;
   value=value+(long)LowByte;

   return value;  
}



/*********************************************************************/
/* Creates and returns a short int from 2 bytes.                     */ 
/*********************************************************************/
SHORT CreateShortFrom2Bytes(BYTE HighByte, BYTE LowByte) {
   short value;

   value=(short)HighByte;
   value=value << 8;
   value=value+(short)LowByte;

   return value;  
}



/*********************************************************************/
/* Converts a hexadesimal repr. to a decimal value. Ex 1Ah(26)->20   */ 
/*                                                     19h(25)->19   */
/*                                                     98h(152)->98  */    
/*********************************************************************/
BYTE bHex2Dec(BYTE byte)
{
   BYTE LoNibble=byte & 15;
   BYTE HiNibble=byte >> 4;
   return (BYTE)(HiNibble*10+LoNibble);
}


/*********************************************************************/
/* Causes the window to be repainted.                                */
/*********************************************************************/
void Updatewindow(HWND hWnd)
{
   RECT rect;

   GetClientRect(hWnd, &rect);
   InvalidateRect(hWnd, &rect, TRUE);
   UpdateWindow(hWnd);
};





/*********************************************************************/
/* Write a number of bytes from memory to file.                      */
/* The file will be created and sized as nessecarry.                 */
/*********************************************************************/
BOOL WriteFileFromMemory(LPCTSTR FileName, PVOID Buffer, DWORD NumOfBytes) {

   HANDLE hFile;
   DWORD BytesWritten;

   // Open the file. Create if it does not exist.
   hFile=CreateFile(FileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

   // If CreateFile failed then exit.
   if (hFile==INVALID_HANDLE_VALUE) return FALSE;

   // Write bytes to file.
   WriteFile(hFile, (LPCVOID)Buffer, NumOfBytes, &BytesWritten, NULL);
   
   // Close the file.
   SetEndOfFile(hFile);
   CloseHandle(hFile);
  
   // Check that bytes where written.
   if (NumOfBytes!=BytesWritten) return FALSE;

   return TRUE;

}



/*********************************************************************/
/* Read a number of bytes from file to memory.                       */
/*********************************************************************/
BOOL ReadFileToMemory(LPCTSTR FileName, PVOID Buffer, DWORD NumOfBytes) {

   HANDLE hFile;
   DWORD BytesRead;

   // Open the file. 
   hFile=CreateFile(FileName, GENERIC_READ, 0, NULL, OPEN_EXISTING,  FILE_ATTRIBUTE_NORMAL, NULL);

   // If CreateFile failed then exit.
   if (hFile==INVALID_HANDLE_VALUE) return FALSE;

   // Read bytes to memory.
   ReadFile(hFile, Buffer, NumOfBytes, &BytesRead, NULL);
   
   // Close the file.
   CloseHandle(hFile);
  
   // Check that bytes where read.
   if (NumOfBytes!=BytesRead) return FALSE;

   return TRUE;

}



/*********************************************************************/
/* Removes the last backslash from a path if it exists.              */
/*********************************************************************/
VOID StripBackslashFromPath(TCHAR *Path) {
    int strsize;
    TCHAR *CharPtr;

    // Find length of the path.
    strsize=wcslen(Path);

    // Does this path include
    // a drive spesification?
    CharPtr=wcschr(Path, ':');

    // Return if we are on the root level.
    if (CharPtr!=NULL && strsize<=3) return;
    if (CharPtr==NULL && strsize==1) return;

    // Remove backslash if it exists.
    if (Path[strsize-1]=='\\') Path[strsize-1]=0;
}





/*********************************************************************************/
/* Returns a pointer to start of a devicemanager datablock given by 'BlockNr'.   */
/*********************************************************************************/
PVOID GetPointerToBlock(DEVMNGR_INTERF_STRUCT *DDS, WORD ChannelNr, DWORD BlockNr)
{
   BYTE *pChannelData;

   // Check input values.
   if (DDS==(DEVMNGR_INTERF_STRUCT*)NULL) return (PVOID)NULL;
   if (BlockNr>=DDS->NumBlocksPrChannel) return (PVOID)NULL;
   if (ChannelNr>DDS->NumChannels) return (PVOID)NULL;
   
   // Get pointer to start of channeldata
   pChannelData=(BYTE*)DDS->ChannelData[ChannelNr-1];
   
   // Get pointer to start of block 'BlockNr'.
   return (PVOID)(pChannelData+(BlockNr*DDS->BlockSize));

}



/****************************************************************/
/* Returns a block header for a channel thread block given the  */
/* block number and a pointer to a buffer properties structure. */
/****************************************************************/
VOID GetChannelBlockHeader(DWORD BlockNr, BLOCK_HEADER *BlockHdr, BUFF_PROP *BufProp)
{
   BYTE *bPtr;

   bPtr=(BYTE*)BufProp->pBuffer+(BufProp->BlocksizeInBytes*BlockNr);
   *BlockHdr=*((BLOCK_HEADER*)bPtr);

   return;
}





/*********************************************************************/
/* Deletes all files in a directory.                                 */
/* Does not delete the directory itself.                             */
/*********************************************************************/
BOOL ClearDirectory(PTCHAR Directory)
{
   TCHAR FileSpec[MAX_PATH+1]; 
   HANDLE SearchHndl;
   WIN32_FIND_DATA FileData;

   // Build filespecification string.
   AddPathAndFilename(FileSpec, Directory, TEXT("*.*"));

   // Find the first file/directory.
   if ((SearchHndl=FindFirstFile(FileSpec, &FileData))==INVALID_HANDLE_VALUE) return FALSE;
   if (!(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
      AddPathAndFilename(FileSpec, Directory, FileData.cFileName);
      if (!DeleteFile(FileSpec)) return FALSE;
   }
  
   // Process the rest of the files/directories.
   while (FindNextFile(SearchHndl, &FileData)) {
      if (!(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
         AddPathAndFilename(FileSpec, Directory, FileData.cFileName);
         if (!DeleteFile(FileSpec)) return FALSE;
      }
   }

   // Close the handle.
   FindClose(SearchHndl);

   return TRUE;
}

/*********************************************************************/
/* Returns a random number in the range from LowValue to HighValue.  */
/*********************************************************************/
int GetRandomNumber(int LowValue, int HighValue) 
{
   int RandomNumber; 
   float DivFactor, dValue;

   // Check input values.
   if (LowValue<0) LowValue=0;
   if (HighValue>RAND_MAX) HighValue=RAND_MAX;

   // Get the random number.
   RandomNumber=rand();
   RandomNumber=rand();

   // Calculate the division factor which
   // the random number must be divided with.
   DivFactor=(float)RAND_MAX/(float)(HighValue-LowValue);

   // Calculate the value to return.
   dValue=(float)RandomNumber/DivFactor;
   RandomNumber=(int)dValue;
   if (dValue>=(float)(RandomNumber+0.5)) RandomNumber++;
   RandomNumber=RandomNumber+LowValue;

   return RandomNumber;
}



/*****************************************************/
/* Clear the calling threads message queue.          */
/*****************************************************/
VOID ClearMessageQueue(VOID)
{
   MSG msg;

   while(PeekMessage(&msg, (HWND)NULL, 0, 0, PM_REMOVE));

}




/***************************************************************/
/* Draws a bitmap in a window identified by a device context.  */
/***************************************************************/

VOID DrawBitmap(HDC hdc, HBITMAP hBitmap, INT xStart, INT yStart)
{
   BITMAP bm;
   HDC hdcMem;
   POINT ptSize,ptOrg;

   hdcMem=CreateCompatibleDC(hdc);
   SelectObject(hdcMem, hBitmap);
#ifndef WINCE
   SetMapMode(hdcMem, GetMapMode(hdc));
#endif
   GetObject(hBitmap, sizeof(BITMAP), (LPSTR) &bm);
   ptSize.x=bm.bmWidth;
   ptSize.y=bm.bmHeight;
#ifndef WINCE
   DPtoLP(hdc, &ptSize, 1);
#endif
   ptOrg.x=0;
   ptOrg.y=0;
#ifndef WINCE
   DPtoLP(hdcMem, &ptOrg, 1);
#endif
   BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y, hdcMem, ptOrg.x, ptOrg.y, SRCCOPY);
   DeleteDC(hdcMem);
}


/***************************************************************/
/* Draws a bitmap in a window identified by a device context.  */
/* The drawing starts from an offset in the bitmap.            */
/***************************************************************/

VOID DrawBitmap2(HDC hdc,HBITMAP hBitmap,INT xStart, INT yStart, INT xOffset, INT yOffset)
{
   BITMAP bm;
   HDC hdcMem;
   POINT ptSize,ptOrg;

   hdcMem=CreateCompatibleDC(hdc);
   SelectObject(hdcMem, hBitmap);
#ifndef WINCE
   SetMapMode(hdcMem, GetMapMode(hdc));
#endif
   GetObject(hBitmap, sizeof(BITMAP), (LPSTR) &bm);
   ptSize.x=bm.bmWidth;
   ptSize.y=bm.bmHeight;
#ifndef WINCE
   DPtoLP(hdc, &ptSize, 1);
#endif
   ptOrg.x=xOffset;
   ptOrg.y=yOffset;
#ifndef WINCE
   DPtoLP(hdcMem, &ptOrg, 1);
#endif
   BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y,
               hdcMem, ptOrg.x, ptOrg.y, SRCCOPY);
   DeleteDC(hdcMem);
}


/******************************************************/
/* Calculates a Julian Day number.                    */
/******************************************************/
DWORD JulianDay(SYSTEMTIME *Time) 
//
//  JULIAN PERIOD WAS DEVISED BY JOSEPH SCALIGER IN 1582.
//  JULIAN DAY NUMBER #1 STARTED ON JAN. 1,4713 B.C. THREE MAJOR
//  CHRONOLOGICAL CYCLES BEGIN ON THE SAME DAY. A 28-YEAR SOLAR
//  CYCLE, A 19-YEAR LUNER CYCLE, A 15-YEAR INDICTION CYCLE, USED
//  IN ANCIENT ROME TO REGULATE TAXES. IT WILL TAKE 7980 YEARS
//  TO COMPLETE THE PERIOD, THE PRODUCT OF 28, 19, AND 15.
//  SCALIGER NAMED THE PERIOD, DATE, AND NUMBER AFTER HIS FATHER
//  JULIUS (NOT AFTER THE JULIAN CALENDAR).
//
{
   LONG A,B,C,E,F;
   WORD Year, Month;

   // Copy information to local variables.   
   Year=Time->wYear;
   Month=Time->wMonth;

   // Calculate Julian day.
   if (Month<=2) { Year=Year-1; Month=Month+12;}
   A=Year/100; B=A/4; C=2-A+B;
   E=(LONG)(DOUBLE)(365.25*(Year+4716));
   F=(LONG)(DOUBLE)(30.6001*(Month+1));
   return (DWORD)(C+Time->wDay+E+F-1525);
}



/***********************************************************/
/* Calculates a date from a julian date number.            */
/***********************************************************/
VOID RJulianDay(WORD *Day, WORD *Month, WORD *Year, DWORD JD) 
{
   LONG A,B,C,D,E,F,W,X,Z;

   Z=JD+1;
   W=(LONG)(DOUBLE)((Z-1867216.25)/36524.25);
   X=(LONG)W/4;
   A=Z+1+W-X;
   B=A+1524;
   C=(LONG)(DOUBLE)((B-122.1)/365.25);
   D=(LONG)(365.25*C);
   E=(LONG)(DOUBLE)((B-D)/30.6001);
   F=(LONG)(30.6001*E);
   *Day=(WORD)(B-D-F);
   if (E<14) *Month=(WORD)(E-1);
   if (E>=14) *Month=(WORD)(E-13);
   if (*Month<=2) *Year=(WORD)(C-4715);
   if (*Month>2) *Year=(WORD)(C-4716);

   return;
}



/*************************************************************/
/* Compares two SYSTEMTIME structures and return the result. */
/*************************************************************/
char TimeCmp(SYSTEMTIME *Time1, SYSTEMTIME *Time2) 
{
//
// Return Value.
//
// The return value for this function 
// indicates the relation of Time1 to Time2.
// 
// -1 Time1 earlier than Time2
//  0 Time1 is identical to Time2
//  1 Time1 is later than Time2
//
   
   if (Time1->wYear<Time2->wYear) return -1;
   if (Time1->wYear>Time2->wYear) return 1;   
   if (Time1->wMonth<Time2->wMonth) return -1;
   if (Time1->wMonth>Time2->wMonth) return 1;   
   if (Time1->wDay<Time2->wDay) return -1;
   if (Time1->wDay>Time2->wDay) return 1;   
   if (Time1->wHour<Time2->wHour) return -1;
   if (Time1->wHour>Time2->wHour) return 1;   
   if (Time1->wMinute<Time2->wMinute) return -1;
   if (Time1->wMinute>Time2->wMinute) return 1;   
   if (Time1->wSecond<Time2->wSecond) return -1;
   if (Time1->wSecond>Time2->wSecond) return 1;   
   if (Time1->wMilliseconds<Time2->wMilliseconds) return -1;
   if (Time1->wMilliseconds>Time2->wMilliseconds) return 1;   

   return 0;
}



/*************************************************************/
/* Calculates the timedifference in seconds between          */
/* two SYSTEMTIME structures and return the absolute result. */
/*************************************************************/
DOUBLE TimeDiff(SYSTEMTIME *Time1, SYSTEMTIME *Time2) 
{
   DOUBLE Diff, DaySeconds1, DaySeconds2;
   CHAR CmpResult;
   LONG WholeDayDiff;

   // Compare the two times.
   CmpResult=TimeCmp(Time1, Time2);

   // Check if the times are equal.
   if (!CmpResult) return 0.0;

   // Calculate number of whole days elased between the two times.
   WholeDayDiff=(LONG)(JulianDay(Time1)-JulianDay(Time2));

   // Calculate number of seconds elapsed since the start of the day.
   DaySeconds1=Time1->wHour*3600+Time1->wMinute*60+Time1->wSecond+(Time1->wMilliseconds/1000.0);
   DaySeconds2=Time2->wHour*3600+Time2->wMinute*60+Time2->wSecond+(Time2->wMilliseconds/1000.0);
   
   // Calculate the total time-difference in seconds.
   Diff=fabs(WholeDayDiff*86400);
   if (CmpResult==-1 && DaySeconds1< DaySeconds2) Diff=Diff+DaySeconds2-DaySeconds1; 
   if (CmpResult==-1 && DaySeconds1>=DaySeconds2) Diff=Diff+DaySeconds2-DaySeconds1;
   if (CmpResult== 1 && DaySeconds1< DaySeconds2) Diff=Diff+DaySeconds1-DaySeconds2;
   if (CmpResult== 1 && DaySeconds1>=DaySeconds2) Diff=Diff+DaySeconds1-DaySeconds2;
 
   return Diff;
}



/*********************************************************/
/* Adds a given number of seconds to a time and returns  */
/* the new time resulting from the addition.             */
/*********************************************************/
VOID AddToTime(SYSTEMTIME *Time, DOUBLE Seconds) 
{
   DWORD JD;
   WORD Year, Month, Day, Hour, Minute, Second, Milliseconds, Days;
   DOUBLE TotalSeconds;

   // Check the value of Seconds.
   if (Seconds<=0.0) return;

   // Calculate Julian Day for the incoming time.
   JD=JulianDay(Time);

   // Calculate number of seconds elapsed since 
   // the start of the day of the incoming time.
   TotalSeconds=Time->wHour*3600+Time->wMinute*60+Time->wSecond+(Time->wMilliseconds/1000.0);

   // Now add the incoming number of seconds.
   TotalSeconds=TotalSeconds+Seconds;

   // Convert total number of seconds to whole days.
   Days=(WORD)(TotalSeconds/86400);

   // Add number of days found to the Julian day value, and substract
   // the corresponding number of seconds fron the Sec value.
   JD=JD+Days;
   TotalSeconds=TotalSeconds-(Days*86400.0);

   // Convert the new julian day value back to a date.
   RJulianDay(&Day, &Month, &Year, JD); 

   // Convert the remaining seconds to a time of day.
   Hour=(WORD)(TotalSeconds/3600); TotalSeconds=TotalSeconds-(Hour*3600.0);
   Minute=(WORD)(TotalSeconds/60); TotalSeconds=TotalSeconds-(Minute*60.0);
   Second=(WORD)(TotalSeconds);    TotalSeconds=TotalSeconds-Second;
   Milliseconds=(WORD)(TotalSeconds*1000);
   
   // Return the new time.
   Time->wYear=Year;
   Time->wMonth=Month;
   Time->wDayOfWeek=0;
   Time->wDay=Day;
   Time->wHour=Hour;
   Time->wMinute=Minute;
   Time->wSecond=Second;
   Time->wMilliseconds=Milliseconds;
   
   return;
}



/*********************************************************/
/* Adds exactly one second to a time and returns         */
/* the new time resulting from the addition.             */
/*********************************************************/
VOID AddOneSecondToTime(SYSTEMTIME *Time)
{
   if (Time->wSecond < 59) {
      Time->wSecond++;
   } else {
      AddToTime(Time, 1.0); 
   }
}




/*********************************************************/
/* Substracts a given number of seconds from a time and  */
/* returns the new time resulting from the substraction. */
/*********************************************************/
VOID SubstractFromTime(SYSTEMTIME *Time, DOUBLE Seconds) 
{
   DWORD JD;
   WORD Year, Month, Day, Hour, Minute, Second, Milliseconds;
   WORD SDays;
   DOUBLE SecsSinceStartOfDay, SSeconds;

   // Check the value of Seconds.
   if (Seconds<=0.0) return;

   // Calculate Julian-Day for the incoming time.
   JD=JulianDay(Time);

   // Calculate number of seconds elapsed since 
   // the start of the day of the incoming time.
   SecsSinceStartOfDay=Time->wHour*3600+Time->wMinute*60+Time->wSecond+(Time->wMilliseconds/1000.0);

   // Divide the incoming seconds into days and seconds.
   SDays=(WORD)(Seconds/86400);
   SSeconds=Seconds-(SDays*86400.0);

   // Substract seconds from time.   
   if (SecsSinceStartOfDay>=SSeconds) {
      JD=JD-SDays;                                       // Calculate a new JD value.
      SecsSinceStartOfDay=SecsSinceStartOfDay-SSeconds;  // Calculate a new seconds value.
   } else {
      JD=JD-SDays-1;                                   
      SecsSinceStartOfDay=86400.0+SecsSinceStartOfDay-SSeconds;   
   }

   // Convert the new julian day value back to a date.
   RJulianDay(&Day, &Month, &Year, JD); 

   // Convert the remaining seconds to a time of day.
   Hour=(WORD)(SecsSinceStartOfDay/3600); SecsSinceStartOfDay=SecsSinceStartOfDay-(Hour*3600.0);
   Minute=(WORD)(SecsSinceStartOfDay/60); SecsSinceStartOfDay=SecsSinceStartOfDay-(Minute*60.0);
   Second=(WORD)(SecsSinceStartOfDay);    SecsSinceStartOfDay=SecsSinceStartOfDay-Second;
   Milliseconds=(WORD)(SecsSinceStartOfDay*1000);
   
   // Return the new time.
   Time->wYear=Year;
   Time->wMonth=Month;
   Time->wDayOfWeek=0;
   Time->wDay=Day;
   Time->wHour=Hour;
   Time->wMinute=Minute;
   Time->wSecond=Second;
   Time->wMilliseconds=Milliseconds;
   
   return;
}





/*************************************************************/
/* Calculates Day Of Year (1-365) and return the result.     */
/*************************************************************/
WORD GetDayOfYear(SYSTEMTIME *Time)
{
   DWORD JDToday, JDStartOfYear;
   SYSTEMTIME TimeStartOfYear;

   // Calculate the Julian day number for current date.
   JDToday=JulianDay(Time);

   // Calculate the Julian day number for 1/1 current year.
   TimeStartOfYear=*Time;
   TimeStartOfYear.wMonth=1;
   TimeStartOfYear.wDay=1;
   JDStartOfYear=JulianDay(&TimeStartOfYear);

   // Return day of year.
   return (WORD)(JDToday-JDStartOfYear+1);
}





/*************************************************************/
/* Deletes a charater from a string.                         */
/* Delets the character pointed to by the zero based index   */
/* pointer 'strptr'. Characters to the right of the deleted  */
/* character are shifted left.                               */
/*************************************************************/
VOID StrDelete(PTCHAR string, INT strptr)
{
   int i, strlngth;

   // Get the length of the string.
   strlngth=wcslen(string);

   // Return if string is empty.
   if (!strlngth) return;

   // Return if strptr is larger then length of string.
   if (strptr>=strlngth) return;

   // Delete character pointed to by strptr.
   for (i=strptr;i<=strlngth-1;i++) string[i]=string[i+1];
    
   return;
}




/**********************************************/
/* Returns position in the string for the     */
/* first occurance of a given character.      */
/**********************************************/
BOOL StrFindChar(PTCHAR Str, TCHAR Char, PINT Pos)
{
   int i, length;

   // Get the length of the string.
   length=wcslen(Str);

   // Return FALSE if string is empty.
   if (!length) return FALSE;

   // Search for 'character' in string.
   for (i=0;i<length;i++) {
      if(Str[i]==Char) { *Pos=i; return TRUE; }
   }

   // If character was not found, return FALSE.
   return FALSE;
}



/*******************************************/
/* Removes all spaces from a string.       */
/*******************************************/
VOID StrRmvSpaces(PTCHAR string)
{
   int i, length;

   length=wcslen(string);
   if (!length) return;
   for (i=length-1;i>=0;i--) {
      if(string[i]==' ') StrDelete(string, i);
   }
}




/******************************************************/
/* Removes all spaces in the start of a string.       */
/******************************************************/
VOID StrRmvTrailingSpaces(PTCHAR string)
{
   while (string[0]==' ') StrDelete(string, 0);
}




/*******************************************/
/* Replaces all spaces with underscores.   */
/*******************************************/
VOID StrSpace2Underscore(PTCHAR string)
{
   int i, length;

   // Find the length of the string.
   length=wcslen(string);

   // If string has zero length then exit.
   if (!length) return;

   // Replace all spaces with underscores.
   for (i=0;i<length;i++) { 
      if(string[i]==' ') string[i]='_'; 
   }
}





/****************************************************************/
/* Inserts the time in the SYSTEMTIME structure into the string. */
/*****************************************************************/
VOID CreateTimeString(SYSTEMTIME *Time, PTCHAR String)
{
   TCHAR str4[5];

   String[0]=0;
   swprintf(str4, TEXT("%02u"), Time->wHour);
   wcscat(String, str4);
   wcscat(String, TEXT(":"));
   swprintf(str4, TEXT("%02u"), Time->wMinute);
   wcscat(String, str4);
   wcscat(String, TEXT(":"));
   swprintf(str4, TEXT("%02u"), Time->wSecond);
   wcscat(String, str4);
   wcscat(String, TEXT("."));
   swprintf(str4, TEXT("%03u"), Time->wMilliseconds);
   wcscat(String, str4);

   return;
}


/****************************************************************/
/* Rounds a double up or down to the nearest whole number.      */
/****************************************************************/
DOUBLE DblRound(DOUBLE Value)
{
   DOUBLE dbValue;
   
   dbValue=fabs(Value);
   dbValue=floor(dbValue);
   if (fabs(Value)-dbValue >= 0.5) dbValue=dbValue+1.0;
   if (Value<0.0) dbValue=-dbValue;

   return dbValue;
}



/***************************************************************************/
/* Returns the average of the samples in a block.                          */
/***************************************************************************/
DOUBLE CalculateBlockAverage(long *pBlockSamples, WORD SamplesPrBlock)
{
   WORD Index;
   LONG Sum=0;
   for (Index=1;Index<=SamplesPrBlock; Index++) {
      Sum=Sum+*pBlockSamples;
      pBlockSamples++;
   }

   return (DOUBLE)Sum/(DOUBLE)SamplesPrBlock;
}



/********************************************************************************/
/* Returns the number of channels currently running, and a list of ThreadID's   */
/* identifying the channels. A pointer to an array of DWORD's must be supplied. */
/********************************************************************************/
BYTE GetRunningChannels(DWORD *Channels)
{
   HANDLE hEvent;
   MSG_PARAM MsgParams;

   MsgParams.vPointer=(PVOID)Channels;
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   PostThreadMessage(ProcKeeperThreadID, TM_GET_CHANNELS, (WPARAM)hEvent, (LPARAM)&MsgParams); 
   WaitForSingleObject(hEvent, INFINITE);
   CloseHandle(hEvent);

   return (BYTE)MsgParams.dwStatus;
}



/*****************************************************************************************/
/* Procedure for subscribing to a message from the thread identified by 'ThreadID'.      */
/* The calling thread must identify itself by either it's thread-id or window handle.    */ 
/*****************************************************************************************/
VOID Subscribe(UINT message, DWORD ThreadID, DWORD ThisThreadID, HWND hThisWindow)
{
   HANDLE hEvent;
   MSG_PARAM MsgParams;
   SUBSCRIBE SubscrData;

   SubscrData.uiMessage=message;
   SubscrData.idThread=ThisThreadID;
   SubscrData.hWnd=hThisWindow;
   MsgParams.vPointer=(PVOID)&SubscrData;
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   PostThreadMessage(ThreadID, TM_SUBSCRIBE, (WPARAM)hEvent, (LPARAM)&MsgParams); 
   WaitForSingleObject(hEvent, INFINITE);
   CloseHandle(hEvent);
}



/*****************************************************************************************/
/* Procedure for unsubscribing to a message from the thread identified by 'ThreadID'.    */
/* The calling thread must identify itself by either it's thread-id or window handle.    */ 
/*****************************************************************************************/
VOID UnSubscribe(UINT message, DWORD ThreadID, DWORD ThisThreadID, HWND hThisWindow)
{
   HANDLE hEvent;
   MSG_PARAM MsgParams;
   SUBSCRIBE SubscrData;

   SubscrData.uiMessage=message;
   SubscrData.idThread=ThisThreadID;
   SubscrData.hWnd=hThisWindow;
   MsgParams.vPointer=(PVOID)&SubscrData;
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   PostThreadMessage(ThreadID, TM_UNSUBSCRIBE, (WPARAM)hEvent, (LPARAM)&MsgParams); 
   WaitForSingleObject(hEvent, INFINITE);
   CloseHandle(hEvent);
}




/************************************************************************/
/* Checks a filename for illegal characters and retuens the status.     */
/* Path MUST be removed from the filename before calling this function. */
/************************************************************************/
BOOL IsValidFileName(TCHAR *FileName)
{
   WORD Index, wcslength;

   // Get the length of the filename.
   wcslength=wcslen(FileName);

   // If length is zero return FALSE.
   if (!wcslength) return FALSE;

   // If length is longer then maximum
   // allowed length then return FALSE.
   if (wcslength>MAX_PATH) return FALSE;

   // Scan for illegal charaters in filename.
   for (Index=0;Index<wcslength;Index++) {
      if (FileName[Index]=='\\') return FALSE;
      if (FileName[Index]=='/') return FALSE;
      if (FileName[Index]==':') return FALSE;
      if (FileName[Index]=='*') return FALSE;
      if (FileName[Index]=='?') return FALSE;
      if (FileName[Index]=='<') return FALSE;
      if (FileName[Index]=='>') return FALSE;
      if (FileName[Index]=='"') return FALSE;
      if (FileName[Index]=='|') return FALSE;
   }

   return TRUE;
}



/***********************************************************************/
/* Function for renaming a file                                        */
/***********************************************************************/
BOOL RenameFile(PTCHAR PathToFile, PTCHAR OldFileName, PTCHAR NewFileName)
{
   TCHAR FullPathOldFile[MAX_PATH+1];
   TCHAR FullPathNewFile[MAX_PATH+1];

   // Build full path to existing file.
   AddPathAndFilename(FullPathOldFile, PathToFile, OldFileName);

   // Build full path to new file.
   AddPathAndFilename(FullPathNewFile, PathToFile, NewFileName);

   // Rename file.
   return MoveFile(FullPathOldFile, FullPathNewFile);
}



/***********************************************************************/
/*This procedure adds a filename to a path and return the result.      */
/***********************************************************************/
VOID AddPathAndFilename(PTCHAR Result, PTCHAR Path, PTCHAR FileName)
{
   wcscpy(Result, Path);            // Insert the path.
   StripBackslashFromPath(Result);  // Remove backslash from path if it exist.
   wcscat(Result, TEXT("\\"));            // Add backslash to path.
   wcscat(Result, FileName);        // Add the filename.
}




/************************************************************************/
/*This procedure returns the current system time syncronization status. */
/************************************************************************/
BYTE GetCurrentTimeSyncStatus(DWORD SysClkSyncThreadID)
{
   HANDLE hEvent;
   MSG_PARAM MsgParams;
   
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   PostThreadMessage(SysClkSyncThreadID, TM_GET_TIMESYNC_STATUS, (WPARAM)hEvent, (LPARAM)&MsgParams); 
   WaitForSingleObject(hEvent, INFINITE);
   CloseHandle(hEvent);
   return (BYTE)MsgParams.wStatus;
   
}




/**********************************************************/
/* Formats and draws a textstring on the status bar       */
/* describing the current syncronization status.          */
/**********************************************************/  
VOID DrawStatusBarText(BYTE SyncStatus, PTCHAR ProcName)
{
   if (!wcslen(ProcName)) return;
   //wcscpy(StatusBarText, TEXT("Time sync. by "));
   //wcscat(StatusBarText, ProcName);
   //wcscat(StatusBarText, TEXT("  -  Status: "));
   wcscpy(StatusBarText, TEXT("Time sync status: "));
   if (SyncStatus==0) wcscat(StatusBarText, TEXT("OK"));
   if (SyncStatus==1) wcscat(StatusBarText, TEXT("No satellite fix"));
   if (SyncStatus==2) wcscat(StatusBarText, TEXT("Communication error"));
   PostMessage(hWndStatus, SB_SETTEXT, (WPARAM) 0, (LPARAM)(LPSTR) StatusBarText);
}




/****************************************************************/
/* Tries to read 'BytesToRead' number of bytes from a COM port. */
/* Function will timeout after 'TotalTimeOut' ms, if bytes not  */
/* read. Function will timeout if more then 'IntervalTimeout'   */
/* ms elapses between two characters on the comm port.      	 */ 
/* The timeouts are unaccurate - maybe up to about 100 ms.      */ 
/* Function returns number of bytes actually read.              */
/****************************************************************/
DWORD ReadComPort(HANDLE hComm, PBYTE Buffer, DWORD BytesToRead, 
						DWORD TotalTimeOut, DWORD ReadIntervalTimeout)
{
	BYTE ComBytes[32];
	DWORD NumBytesInBuffer, BytesRead, LastByteReadTicker;
	DWORD StartTicker, CurrentTicker, TimeElapsed, NumBytesToRead;
	COMMTIMEOUTS ct={MAXDWORD, 0, 0, 0, 0};
	BOOL Finished, BytesHasBeenRead;

	// Initialize variables.
	NumBytesInBuffer=0;
	Finished=BytesHasBeenRead=FALSE;

	// Set comm timeouts.
	SetCommTimeouts(hComm, &ct);

	// Get the value of the system timer ticker.
	StartTicker=GetTickCount();

	// Read from comm port in a loop.
	while (!Finished) {

		// Calculate how many bytes to read from comm port.
		// Bytes will be read in blocks of 32 bytes or less.
		NumBytesToRead=BytesToRead-NumBytesInBuffer;
		if (NumBytesToRead>32) NumBytesToRead=32;

		// Try to read from serial port.
		ReadFile(hComm, (PVOID)&ComBytes, NumBytesToRead, &BytesRead, NULL);

		// Save the ticker count when the bytes was read.
		CurrentTicker=GetTickCount();

		// Handle the read result.
		if (BytesRead) {  // One or several bytes was read.

			// Indicate that bytes has been read.
			BytesHasBeenRead=TRUE;

			// Save the time when the last byte was read.
			LastByteReadTicker=CurrentTicker;

			// Insert bytes into buffer.
			CopyMemory((PVOID)(Buffer+NumBytesInBuffer), (PVOID)&ComBytes, BytesRead);

			// Move buffer pointer.
			NumBytesInBuffer=NumBytesInBuffer+BytesRead;

			// If we have read the requested number of bytes, we're done.
			if (NumBytesInBuffer==BytesToRead) Finished=TRUE;

		} else { // Nothing was read.

			// Handle the ReadInterval timeout.
			if (BytesHasBeenRead) { 
				// Calculate time since the last byte was read.
				TimeElapsed=CalcElapsedTickerTime(LastByteReadTicker, CurrentTicker);
				if (TimeElapsed>=ReadIntervalTimeout) Finished=TRUE;
			}

			// Wait a few ms for more bytes to arrive on the comm port.
			Sleep(15);
		}

		// We are done if TotalTimeOut time has been reached.
		TimeElapsed=CalcElapsedTickerTime(StartTicker, CurrentTicker);
		if (TimeElapsed>=TotalTimeOut) Finished=TRUE;
	}

   // Return number of bytes read.
   return NumBytesInBuffer;
}



/***************************************************************/
/* Calculates the elapsed time (in ms) between two timerticks. */
/***************************************************************/
DWORD CalcElapsedTickerTime(DWORD StartTick, DWORD EndTick)
{
	if (EndTick >= StartTick) return (EndTick-StartTick);
   return (MAXDWORD-StartTick+EndTick+1);
}

#ifndef WINCE
/*****************************************************/
/* Disable a window menu.                            */
/*****************************************************/
VOID DisableMenu(HWND hWnd) 
{
   HMENU hMenu;
   INT Index, NumMenuItems;

   // Get handle to the programs menu.
   hMenu=GetMenu(hWnd); 

   // Get number of submenus.
   NumMenuItems=GetMenuItemCount(hMenu);

   // Disable all submenus.
   for (Index=0;Index<NumMenuItems;Index++) {
      EnableMenuItem(hMenu, Index, MF_GRAYED|MF_DISABLED|MF_BYPOSITION); 
   }

   // Redraw the menu bar.
   DrawMenuBar(hWnd);

}



/******************************************************/
/* Enable a window menu.                              */
/******************************************************/
VOID EnableMenu(HWND hWnd) 
{
   HMENU hMenu;
   INT Index, NumMenuItems;

   // Get handle to the programs menu.
   hMenu=GetMenu(hWnd); 

   // Get number of submenus.
   NumMenuItems=GetMenuItemCount(hMenu);

   // Enable all submenus.
   for (Index=0;Index<NumMenuItems;Index++) {
      EnableMenuItem(hMenu, Index, MF_ENABLED|MF_BYPOSITION); 
   }

   // Redraw the menu bar.
   DrawMenuBar(hWnd);
}

#endif