// 
// Structure describig the contents of the ringbuffer status file.
// 
struct RINGBUFFER_STATUS { 
	DWORD LastFileWritten;	  // The last bufferfile sucessfully written.
	DWORD SampleBytesInFile;  // Sample bytes currently written to the file.
};


//
// Structure describig the contents of the 'ringbuffer.cnf' file.
//
struct RINGBUFFER_CONFIG { 
	WORD RngBufSizeInDays;  // The ringbuffer size measured in days.
	DWORD NumOfFiles;			// Number of files in ring-buffer.
	DWORD FileSize;			// The size of each ring-buffer file measured in bytes.
	DWORD BlocksInFile;		// Number of device blocks in file.
	DWORD SamplesInFile;    // Number of samples in each file.
	WORD FileSizeInMinutes; // The size of each ring-buffer file measured in minutes.
	BYTE BytesPrSample;     // The number of bytes in each sample. Must be 2 or 4.
};


//
// This structure is used to pass startup 
// information to a ring-buffer thread.
//
struct STARTINFO_RINGBUFFER { 
	HWND hWndFrame;						// Handle to program's main window.
	HINSTANCE hInst;						// Handle to program instance.
	DWORD ProcKeeprThreadID;			// ThreadID of process-keeper thread
	DWORD ChnMngrThreadID;				// ThreadID of the channel-manager thread.
	TCHAR RingBufferDir[MAX_PATH+1];  // Directory for ring-buffer files.
	TCHAR ConfigFileDir[MAX_PATH+1];  // Directory for ring-buffer configuration file.
	BYTE ChannelNr;						// Physical device channel to log data from.
	BYTE LogicalChNr;						// The logical channel nr. for the thread.
	TCHAR NetworkName[29+1];				// Name of network.
	TCHAR StationCode[5+1];				// Station code.
	TCHAR Component[4+1];					// Component.
	WORD BlockSizeInMS;					// The size of each block measured in ms.
	WORD SamplesPrBlock;					// Number of samples in each block.
	WORD BlockSize;						// Size of each block measured in bytes.
	WORD SampleRate;						// Device samplerate.
	VOID *pMemBuffer;						// Pointer to channel manager's ringbuffer.
	HANDLE StartEvent;					// Handle to an event object. The ringbuffer
												// must signal this event when properly started.	
};


struct STARTUPINFO_DLG {
	BYTE ChannelNr;
	WORD BlockSizeInMS;
	WORD SamplesPrBlock;
	TCHAR RingBufferDir[MAX_PATH+1];
	RINGBUFFER_CONFIG RngBufConf;
};
